unit frmTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, bbmDataMerge, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    Memo3: TMemo;
    Bevel1: TBevel;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
  private
    procedure DoLookup(Sender: TObject; Source: string; var ReplaceWith: string);
    procedure DoProgress(Sender: TObject; Percent: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  DataMerge: TBBMDataMerge;
begin
  progressbar1.position := 0;
  progressbar1.visible := true;
  DataMerge := TBBMDataMerge.Create(nil);
  with DataMerge do begin
    vars.clear;
    if sender = Button2 then begin
      vars.add('Company Name', 'Acme Products');
      vars.add('Product Name', 'The Doohickey');
      vars.add('First Name', 'John');
      vars.add('Last Name', 'Doe');
    end;
    OnProgress := DoProgress;
    OnLookup := DoLookup;
    DelimStart := '{%';
    DelimEnd := '%}';
    SourceText := memo1.text;
    merge;
    memo2.text := ResultText;
  end;
  progressbar1.visible := false;
  FreeAndNil(DataMerge);
end;

procedure TForm1.DoLookup(Sender: TObject; Source: string; var ReplaceWith: string);
begin
  ReplaceWith := InputBox('Enter Merge Variable Value', 'Value for "' + Source + '":', '');
  TBBMDataMerge(Sender).Vars.Add(Source, ReplaceWith);
end;

procedure TForm1.DoProgress(Sender: TObject; Percent: Integer);
begin
  ProgressBar1.Position := Percent;
end;

end.
